# wxHelpController Class Reference
[Help]

`#include <wx/help.h>`

Inheritance diagram for wxHelpController:
[legend]

## Detailed Description

This is a family of classes by which applications may invoke a help viewer to provide on-line help.

A help controller allows an application to display help, at the contents or at a particular topic, and shut the help program down on termination. This avoids proliferation of many instances of the help viewer whenever the user requests a different topic via the application's menus or buttons.

Typically, an application will create a help controller instance when it starts, and immediately call wxHelpController::Initialize to associate a filename with it. The help viewer will only get run, however, just before the first call to display something.

Most help controller classes actually derive from wxHelpControllerBase and have names of the form wxXXXHelpController or wxHelpControllerXXX. An appropriate class is aliased to the name wxHelpController for each platform, as follows:

- On desktop Windows, wxCHMHelpController is used (MS HTML Help).
- On Windows CE, wxWinceHelpController is used.
- On all other platforms, wxHtmlHelpController is used if wxHTML is compiled into wxWidgets; otherwise wxExtHelpController is used (for invoking an external browser).

The remaining help controller classes need to be named explicitly by an application that wishes to make use of them.

The following help controller classes are defined:

- wxWinHelpController, for controlling Windows Help.
- wxCHMHelpController, for controlling MS HTML Help. To use this, you need to set wxUSE_MS_HTML_HELP to 1 in setup.h and have the htmlhelp.h header from Microsoft's HTML Help kit. (You don't need the VC++-specific htmlhelp.lib because wxWidgets loads necessary DLL at runtime and so it works with all compilers.)
- wxBestHelpController, for controlling MS HTML Help or, if Microsoft's runtime is not available, wxHtmlHelpController. You need to provide both CHM and HTB versions of the help file. For wxMSW only.
- wxExtHelpController, for controlling external browsers under Unix. The default browser is Netscape Navigator. The 'help' sample shows its use.
- wxWinceHelpController, for controlling a simple ``.htm help controller for Windows CE applications.
- wxHtmlHelpController, a sophisticated help controller using wxHTML, in a similar style to the Microsoft HTML Help viewer and using some of the same files. Although it has an API compatible with other help controllers, it has more advanced features, so it is recommended that you use the specific API for this class instead. Note that if you use .zip or .htb formats for your books, you must add this line to your application initialization:

       wxFileSystem::AddHandler(new wxArchiveFSHandler);

  or nothing will be shown in your help window.

##

Library: wxBase

Category: Help

See also:
  wxHtmlHelpController, wxHTML Overview

## Public Member Functions
| wxHelpController (wxWindow *parentWindow=NULL)
| Constructs a help instance object, but does not invoke the help viewer.
| ~wxHelpController ()
| Destroys the help instance, closing down the viewer if it is running.
virtual bool | DisplayBlock (long blockNo)
| If the help viewer is not running, runs it and displays the file at the given block number.
virtual bool | DisplayContents ()
| If the help viewer is not running, runs it and displays the contents.
virtual bool | DisplayContextPopup (int contextId)
| Displays the section as a popup window using a context id.
virtual bool | DisplaySection (const wxString &section)
| If the help viewer is not running, runs it and displays the given section.
virtual bool | DisplaySection (int sectionNo)
| If the help viewer is not running, runs it and displays the given section.
virtual bool | DisplayTextPopup (const wxString &text, const wxPoint &pos)
| Displays the text in a popup window, if possible.
virtual wxFrame * | GetFrameParameters (const wxSize *size=NULL, const wxPoint *pos=NULL, bool *newFrameEachTime=NULL)
| For wxHtmlHelpController, returns the latest frame size and position settings and whether a new frame is drawn with each invocation.
virtual wxWindow * | GetParentWindow () const
| Returns the window to be used as the parent for the help window.
virtual bool | KeywordSearch (const wxString &keyWord, wxHelpSearchMode mode=wxHELP_SEARCH_ALL)
| If the help viewer is not running, runs it, and searches for sections matching the given keyword.
virtual bool | LoadFile (const wxString &file=wxEmptyString)
| If the help viewer is not running, runs it and loads the given file.
virtual bool | OnQuit ()
| Overridable member called when this application's viewer is quit by the user.
virtual bool | Quit ()
| If the viewer is running, quits it by disconnecting.
virtual void | SetFrameParameters (const wxString &title, const wxSize &size, const wxPoint &pos=wxDefaultPosition, bool newFrameEachTime=false)
| For wxHtmlHelpController, the title is set (with s indicating the page title) and also the size and position of the frame if the frame is already open.
virtual void | SetParentWindow (wxWindow *parentWindow)
| Sets the window to be used as the parent for the help window.
virtual void | SetViewer (const wxString &viewer, long flags)
| Sets detailed viewer information.
virtual bool | Initialize (const wxString &file)
| Initializes the help instance with a help filename, and optionally a server socket number if using wxHelp (now obsolete).
virtual bool | Initialize (const wxString &file, int server)
| Initializes the help instance with a help filename, and optionally a server socket number if using wxHelp (now obsolete).

List of all members.

## Constructor & Destructor Documentation

wxHelpController::wxHelpController | ( | wxWindow * | parentWindow = `NULL` | ) |

Constructs a help instance object, but does not invoke the help viewer.

If you provide a window, it will be used by some help controller classes, such as wxCHMHelpController, wxWinHelpController and wxHtmlHelpController, as the parent for the help window instead of the value of wxApp::GetTopWindow.

You can also change the parent window later with SetParentWindow().

wxHelpController::~wxHelpController | ( |  | ) |

Destroys the help instance, closing down the viewer if it is running.

## Member Function Documentation

virtual bool wxHelpController::DisplayBlock | ( | long | blockNo | ) | `[virtual]`

If the help viewer is not running, runs it and displays the file at the given block number.

- WinHelp: Refers to the context number.
- MS HTML Help: Refers to the context number.
- External HTML help: the same as for DisplaySection().
- wxHtmlHelpController: sectionNo is an identifier as specified in the ``.hhc file. See Help Files Format.

Deprecated:
  This function is for backward compatibility only, and applications should use DisplaySection() instead.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::DisplayContents | ( |  | ) | `[virtual]`

If the help viewer is not running, runs it and displays the contents.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::DisplayContextPopup | ( | int | contextId | ) | `[virtual]`

Displays the section as a popup window using a context id.

Returns false if unsuccessful or not implemented.

virtual bool wxHelpController::DisplaySection | ( | int | sectionNo | ) | `[virtual]`

If the help viewer is not running, runs it and displays the given section.

- WinHelp, MS HTML Help sectionNo is a context id.
- External HTML help: wxExtHelpController implements sectionNo as an id in a map file, which is of the form:
- wxHtmlHelpController: sectionNo is an identifier as specified in the ``.hhc file. See Help Files Format. See also the help sample for notes on how to specify section numbers for various help file formats.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::DisplaySection | ( | const wxString & | section | ) | `[virtual]`

If the help viewer is not running, runs it and displays the given section.

The interpretation of section differs between help viewers. For most viewers, this call is equivalent to KeywordSearch. For MS HTML Help, wxHTML help and external HTML help, if section has a .htm or .html extension, that HTML file will be displayed; otherwise a keyword search is done.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::DisplayTextPopup | ( | const wxString & | text,
|  | const wxPoint & | pos |
| ) |  |  | `[virtual]`

Displays the text in a popup window, if possible.

Returns false if unsuccessful or not implemented.

virtual wxFrame* wxHelpController::GetFrameParameters | ( | const wxSize * | size = `NULL`,
|  | const wxPoint * | pos = `NULL`,
|  | bool * | newFrameEachTime = `NULL` |
| ) |  |  | `[virtual]`

For wxHtmlHelpController, returns the latest frame size and position settings and whether a new frame is drawn with each invocation.

For all other help controllers, this function does nothing and just returns NULL.

Parameters:

  | size | The most recent frame size.
  | pos | The most recent frame position.
  | newFrameEachTime | true if a new frame is drawn with each invocation.

virtual wxWindow* wxHelpController::GetParentWindow | ( |  | ) | const`[virtual]`

Returns the window to be used as the parent for the help window.

This window is used by wxCHMHelpController, wxWinHelpController and wxHtmlHelpController.

virtual bool wxHelpController::Initialize | ( | const wxString & | file,
|  | int | server |
| ) |  |  | `[virtual]`

Initializes the help instance with a help filename, and optionally a server socket number if using wxHelp (now obsolete).

Does not invoke the help viewer. This must be called directly after the help instance object is created and before any attempts to communicate with the viewer.

You may omit the file extension and a suitable one will be chosen. For wxHtmlHelpController, the extensions zip, htb and hhp will be appended while searching for a suitable file. For WinHelp, the hlp extension is appended.

virtual bool wxHelpController::Initialize | ( | const wxString & | file | ) | `[virtual]`

Initializes the help instance with a help filename, and optionally a server socket number if using wxHelp (now obsolete).

Does not invoke the help viewer. This must be called directly after the help instance object is created and before any attempts to communicate with the viewer.

You may omit the file extension and a suitable one will be chosen. For wxHtmlHelpController, the extensions zip, htb and hhp will be appended while searching for a suitable file. For WinHelp, the hlp extension is appended.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::KeywordSearch | ( | const wxString & | keyWord,
|  | wxHelpSearchMode | mode = `wxHELP_SEARCH_ALL` |
| ) |  |  | `[virtual]`

If the help viewer is not running, runs it, and searches for sections matching the given keyword.

If one match is found, the file is displayed at this section. The optional parameter allows the search the index (wxHELP_SEARCH_INDEX) but this currently only supported by the wxHtmlHelpController.

- WinHelp, MS HTML Help: If more than one match is found, the first topic is displayed.
- External HTML help, simple wxHTML help: If more than one match is found, a choice of topics is displayed.
- wxHtmlHelpController: see wxHtmlHelpController::KeywordSearch.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::LoadFile | ( | const wxString & | file = `wxEmptyString` | ) | `[virtual]`

If the help viewer is not running, runs it and loads the given file.

If the filename is not supplied or is empty, the file specified in Initialize() is used.

If the viewer is already displaying the specified file, it will not be reloaded. This member function may be used before each display call in case the user has opened another file.

wxHtmlHelpController ignores this call.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::OnQuit | ( |  | ) | `[virtual]`

Overridable member called when this application's viewer is quit by the user.

This does not work for all help controllers.

Reimplemented in wxExtHelpController.

virtual bool wxHelpController::Quit | ( |  | ) | `[virtual]`

If the viewer is running, quits it by disconnecting.

For Windows Help, the viewer will only close if no other application is using it.

Reimplemented in wxExtHelpController.

virtual void wxHelpController::SetFrameParameters | ( | const wxString & | title,
|  | const wxSize & | size,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | bool | newFrameEachTime = `false` |
| ) |  |  | `[virtual]`

For wxHtmlHelpController, the title is set (with s indicating the page title) and also the size and position of the frame if the frame is already open.

newFrameEachTime is ignored.

For all other help controllers this function has no effect.

Reimplemented in wxExtHelpController.

virtual void wxHelpController::SetParentWindow | ( | wxWindow * | parentWindow | ) | `[virtual]`

Sets the window to be used as the parent for the help window.

This is used by wxCHMHelpController, wxWinHelpController and wxHtmlHelpController.

virtual void wxHelpController::SetViewer | ( | const wxString & | viewer,
|  | long | flags |
| ) |  |  | `[virtual]`

Sets detailed viewer information.

So far this is only relevant to wxExtHelpController. Some examples of usage:

            m_help.SetViewer("kdehelp");
            m_help.SetViewer("gnome-help-browser");
            m_help.SetViewer("netscape", wxHELP_NETSCAPE);

Parameters:

  | viewer | This defaults to "netscape" for wxExtHelpController.
  | flags | This defaults to wxHELP_NETSCAPE for wxExtHelpController, indicating that the viewer is a variant of Netscape Navigator.

Todo:
  modernize this function with wxLaunchDefaultBrowser

Reimplemented in wxExtHelpController.

|  | [ top ]